package de.hdm_stuttgart.battlearena.Controller;

import de.hdm_stuttgart.battlearena.Controller.Utilities.CreateMediaPlayer;
import javafx.fxml.FXML;
import javafx.fxml.FXMLLoader;
import javafx.fxml.Initializable;
import javafx.scene.Cursor;
import javafx.scene.layout.BorderPane;
import javafx.scene.media.MediaPlayer;
import javafx.scene.media.MediaView;

import java.io.File;
import java.io.IOException;
import java.net.URL;
import java.util.Objects;
import java.util.ResourceBundle;

public class IntroController implements Initializable {

    @FXML
    private MediaView mediaView;
    @FXML
    private BorderPane introParent;
    private final String fileName = "src/main/resources/videos/";
    //    nextVideo() will iterate through this array so the next video will be played TODO: change the videos to non memes lmao
    private final String[] videos = {"sony.mp4", "gamecube.mp4", "gameboy.mp4", "monke.mp4"};
    private File file = new File(fileName + videos[0]);
    private int counter = 0;
    private MediaPlayer mediaPlayer;

    @Override
    public void initialize(URL url, ResourceBundle resourceBundle) {
        introParent.setStyle("-fx-background-color: black;");
        introParent.setCursor(Cursor.NONE);
        createMediaPlayer();
    }

    private void createMediaPlayer() {
//        initializing this.mediaPlayer
        mediaPlayer = new CreateMediaPlayer().getMediaPlayer(mediaView, file, true, introParent);
        mediaView.setMediaPlayer(mediaPlayer);

        mediaPlayer.setOnEndOfMedia(() -> {
            if (counter == videos.length - 1) {
                videoEnd();
            } else {
                nextVideo();
            }
        });

//        TODO: make any button pressed work
        introParent.setOnMouseClicked((mouseEvent) -> {
            if (counter == videos.length - 1) {
                videoEnd();
            } else {
                nextVideo();
            }
        });
    }

    private void videoEnd() {
//        TODO: check if player exists
        try {
            mediaPlayer.dispose();
            introParent.getScene().setRoot(FXMLLoader.load(Objects.requireNonNull(getClass().getResource("/fxml/PlayerCreateScene.fxml"))));
        } catch (IOException e) {
            throw new RuntimeException();
        }
    }

    private void nextVideo() {
        mediaPlayer.dispose();
        file = new File(fileName + videos[counter + 1]);
        counter++;
        createMediaPlayer();
    }
}
