package de.hdm_stuttgart.battlearena.Controller;

import de.hdm_stuttgart.battlearena.Controller.Utilities.MusicPlayerSingleton;
import de.hdm_stuttgart.battlearena.Controller.Utilities.SceneLoader;
import javafx.fxml.FXML;
import javafx.fxml.FXMLLoader;
import javafx.fxml.Initializable;
import javafx.scene.control.Slider;
import javafx.scene.layout.VBox;

import java.io.IOException;
import java.net.URL;
import java.util.Objects;
import java.util.ResourceBundle;

public class SettingsController implements Initializable {
    @FXML
    private VBox parent;
    @FXML
    private Slider musicVolume, sfxVolume;
    SceneLoader sceneLoader = new SceneLoader();
    public double music;
    MusicPlayerSingleton musicPlayer = MusicPlayerSingleton.getInstance();

    @Override
    public void initialize(URL url, ResourceBundle resourceBundle) {
        setMusicVolume();
    }

    @FXML
    private void creditScene() throws IOException {
        parent.getChildren().clear();
        parent.getScene().setRoot(FXMLLoader.load(Objects.requireNonNull(getClass().getResource("/fxml/credits.fxml"))));
    }

    @FXML
    private void backButton() {
        parent.getChildren().clear();
        parent.getChildren().add(sceneLoader.loadScene("MainMenu"));
    }

    private void setMusicVolume() {
//        need a runtime database to save volume
        musicVolume.valueProperty().addListener((observableValue, oldValue, newValue) -> {
            setMusic(musicVolume);
            System.out.println(music);
        });
    }

    private void setMusic(Slider slider) {
        slider.valueProperty().addListener(((observableValue, oldValue, newValue) -> {
            music = newValue.doubleValue() / 100;
            musicPlayer.getMediaPlayer().setVolume(music);
        }));
    }
}
