package de.hdm_stuttgart.battlearena.Controller;

import de.hdm_stuttgart.battlearena.Controller.Utilities.SceneLoader;
import javafx.beans.binding.Bindings;
import javafx.collections.FXCollections;
import javafx.collections.ObservableList;
import javafx.fxml.FXML;
import javafx.fxml.Initializable;
import javafx.scene.chart.PieChart;
import javafx.scene.layout.VBox;
import javafx.scene.text.Text;

import java.net.URL;
import java.util.ResourceBundle;

public class StatisticsController implements Initializable {

    @FXML
    private Text blocks, deaths, gameTime, gamesLost, gamesWon, kills;
    @FXML
    private VBox parent;
    @FXML
    private PieChart kd, wl;
    SceneLoader sceneLoader = new SceneLoader();

    public void mainMenuScene() {
        parent.getChildren().clear();
        parent.getChildren().add(sceneLoader.loadScene("MainMenu"));
    }

    @Override
    public void initialize(URL url, ResourceBundle resourceBundle) {
        iniPieChartkd();
        iniPieChartwl();
        kd.setLegendVisible(false);
        wl.setLegendVisible(false);
    }

    public void iniPieChartkd() {
        ObservableList<PieChart.Data> pieChartData =
                FXCollections.observableArrayList(
                        new PieChart.Data("Kills", 20),
                        new PieChart.Data("Deaths", 12));

        pieChartData.forEach(data ->
                data.nameProperty().bind(
                        Bindings.concat(
                                data.getName(), ": ", data.pieValueProperty()
                        )
                )
        );
        kd.getData().addAll(pieChartData);
    }

    public void iniPieChartwl() {
        ObservableList<PieChart.Data> pieChartData =
                FXCollections.observableArrayList(
                        new PieChart.Data("Wins", 3),
                        new PieChart.Data("Losses", 5));

        pieChartData.forEach(data ->
                data.nameProperty().bind(
                        Bindings.concat(
                                data.getName(), ": ", data.pieValueProperty()
                        )
                )
        );
        wl.getData().addAll(pieChartData);
    }
}

