package de.hdm_stuttgart.battlearena.Model.DataStorage.Classes;

import de.hdm_stuttgart.battlearena.Model.DataStorage.Classes.ENUMs.ThreadStatus;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

public class ThreadDLCommMap extends Thread{

    private static final Logger log = LogManager.getLogger(ThreadDLCommMap.class);
    private String mapID;

    @Override
    public void run() {

        Persistence persistenceInst = Persistence.getInstance();
        RuntimeInfo runtimeInfoInst = RuntimeInfo.getInstance();

        try {
            runtimeInfoInst.setThreadDLCommMapMsg("");
            runtimeInfoInst.setThreadDLCommMap(ThreadStatus.RUNNING);
            persistenceInst.getCommunityMap(mapID);
            log.info("Download Community-Map thread finished successfully!");
            runtimeInfoInst.setThreadDLCommMap(ThreadStatus.FINISHED);
        } catch (Exception e) {
            log.error(e);
            runtimeInfoInst.setThreadDLCommMapMsg(e.getMessage());
            log.info("Download Community-Map thread failed!");
            runtimeInfoInst.setThreadDLCommMap(ThreadStatus.FAILED);
        }
    }

    public void startThread(String mapID){
        this.mapID = mapID;
        start();
    }

}
