package de.hdm_stuttgart.battlearena.Model.DataStorage.Classes;

import de.hdm_stuttgart.battlearena.Model.DataStorage.Classes.ENUMs.ThreadStatus;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

public class ThreadGetMapList extends Thread {

    private static final Logger log = LogManager.getLogger(ThreadGetMapList.class);

    @Override
    public void run() {

        Persistence persistenceInst = Persistence.getInstance();
        RuntimeInfo runtimeInfoInst = RuntimeInfo.getInstance();

        try {
            runtimeInfoInst.setThreadCommMapListMsg("");
            runtimeInfoInst.setThreadCommMapList(ThreadStatus.RUNNING);
            persistenceInst.createRemoteCommunityMapsList();
            log.info("Retrieving Community-Map-List thread finished successfully!");
            runtimeInfoInst.setThreadCommMapList(ThreadStatus.FINISHED);
        } catch (Exception e) {
            log.error(e);
            runtimeInfoInst.setThreadCommMapListMsg(e.getMessage());
            log.info("Retrieving Community-Map-List thread failed!");
            runtimeInfoInst.setThreadCommMapList(ThreadStatus.FAILED);
        }
    }

}
