package de.hdm_stuttgart.battlearena.Model.DataStorage.Classes;

import de.hdm_stuttgart.battlearena.Model.DataStorage.Classes.ENUMs.ThreadStatus;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

public class ThreadRstStats extends Thread {

    private static final Logger log = LogManager.getLogger(ThreadRstStats.class);

    @Override
    public void run() {

        Persistence persistenceInst = Persistence.getInstance();
        RuntimeInfo runtimeInfoInst = RuntimeInfo.getInstance();

        try {
            runtimeInfoInst.setThreadRstStatsMsg("");
            runtimeInfoInst.setThreadRstStats(ThreadStatus.RUNNING);
            persistenceInst.resetPlayerStatistics();
            log.info("Reset Player-Statistics thread finished successfully!");
            runtimeInfoInst.setThreadRstStats(ThreadStatus.FINISHED);
        } catch (Exception e) {
            log.error(e);
            runtimeInfoInst.setThreadRstStatsMsg(e.getMessage());
            log.info("Reset Player-Statistics thread failed!");
            runtimeInfoInst.setThreadRstStats(ThreadStatus.FAILED);
        }
    }

}
