package de.hdm_stuttgart.battlearena.Model.DataStorage.Classes;

import de.hdm_stuttgart.battlearena.Model.DataStorage.Classes.ENUMs.ThreadStatus;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

public class ThreadSaveCommMap extends Thread{

    private static final Logger log = LogManager.getLogger(ThreadSaveCommMap.class);
    private MapData map;
    private boolean doUpload;

    @Override
    public void run() {

        Persistence persistenceInst = Persistence.getInstance();
        RuntimeInfo runtimeInfoInst = RuntimeInfo.getInstance();

        try {
            runtimeInfoInst.setThreadSaveCommMapMsg("");
            runtimeInfoInst.setThreadSaveCommMap(ThreadStatus.RUNNING);
            persistenceInst.saveCreatedMap(map, doUpload);
            log.info("Uploading Community-Map thread finished successfully!");
            runtimeInfoInst.setThreadSaveCommMap(ThreadStatus.FINISHED);
        } catch (Exception e) {
            log.error(e);
            runtimeInfoInst.setThreadSaveCommMapMsg(e.getMessage());
            log.info("Uploading Community-Map thread failed!");
            runtimeInfoInst.setThreadSaveCommMap(ThreadStatus.FAILED);
        }
    }

    public void startThread(MapData map, boolean doUpload){     //user can check box to optionally publish map on SQL server
        this.map = map;
        this.doUpload = doUpload;
        start();
    }

}
