package de.hdm_stuttgart.battlearena.Model.DataStorage.Classes;

import de.hdm_stuttgart.battlearena.Model.DataStorage.Classes.ENUMs.ThreadStatus;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

public class ThreadUpdateMaps extends Thread{

    private static final Logger log = LogManager.getLogger(ThreadUpdateMaps.class);

    @Override
    public void run() {

        Persistence persistenceInst = Persistence.getInstance();
        RuntimeInfo runtimeInfoInst = RuntimeInfo.getInstance();

        try {
            runtimeInfoInst.setThreadUpdateMapsMsg("");
            runtimeInfoInst.setThreadUpdateMaps(ThreadStatus.RUNNING);
            persistenceInst.updateCoreMaps();
            log.info("Update Core-Maps thread finished successfully!");
            runtimeInfoInst.setThreadUpdateMaps(ThreadStatus.FINISHED);
        } catch (Exception e) {
            log.error(e);
            runtimeInfoInst.setThreadUpdateMapsMsg(e.getMessage());
            log.info("Update Core-Maps thread failed!");
            runtimeInfoInst.setThreadUpdateMaps(ThreadStatus.FAILED);
        }
    }

}
