package de.hdm_stuttgart.battlearena.Model.DataStorage.Classes;

import de.hdm_stuttgart.battlearena.Model.DataStorage.Classes.ENUMs.ThreadStatus;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

public class ThreadUpdateStats extends Thread{

    private static final Logger log = LogManager.getLogger(ThreadUpdateStats.class);

    @Override
    public void run() {

        Persistence persistenceInst = Persistence.getInstance();
        RuntimeInfo runtimeInfoInst = RuntimeInfo.getInstance();

        try {
            runtimeInfoInst.setThreadUpdateStatsMsg("");
            runtimeInfoInst.setThreadUpdateStats(ThreadStatus.RUNNING);
            persistenceInst.updatePlayerStatistics(runtimeInfoInst.getKills(), runtimeInfoInst.getDeaths(), runtimeInfoInst.getGameTime(), runtimeInfoInst.getBlocksDestroyed(), runtimeInfoInst.isGameWon());
            runtimeInfoInst.setKills(0);
            runtimeInfoInst.setDeaths(0);
            runtimeInfoInst.setGameTime(0);
            runtimeInfoInst.setBlocksDestroyed(0);
            runtimeInfoInst.setGameWon(false);
            log.info("Update statistics thread finished successfully!");
            runtimeInfoInst.setThreadUpdateStats(ThreadStatus.FINISHED);
        } catch (Exception e) {
            log.error(e);
            runtimeInfoInst.setThreadUpdateStatsMsg(e.getMessage());
            log.info("Update statistics thread failed!");
            runtimeInfoInst.setThreadUpdateStats(ThreadStatus.FAILED);
        }
    }

}
