package de.hdm_stuttgart.battlearena.Model.Entity;

import de.hdm_stuttgart.battlearena.Controller.Enum.PlayerMode;
import de.hdm_stuttgart.battlearena.Controller.GameSceneController;
import de.hdm_stuttgart.battlearena.Model.Inputs.InputHandler;

import javafx.scene.canvas.GraphicsContext;

import org.apache.logging.log4j.Logger;
import org.apache.logging.log4j.LogManager;

public class EntityFactory {

    private static final Logger log = LogManager.getLogger(EntityFactory.class);

    public static IEntity createEntity(EntityType entityType, GraphicsContext gameScene, InputHandler inputHandler,
                                       EntityClass entityClass, GameSceneController gameSceneController, PlayerMode playerMode) {
        if (entityType == EntityType.PLAYER) {
            log.debug("Entity " + entityType + " created");
            return new Player(gameScene, inputHandler, entityClass, gameSceneController, playerMode);
        } else if (entityType == EntityType.NETWORK_PLAYER_TWO) {
            log.debug("Entity " + entityType + " created");
            return new NetworkPlayerTwo();
        }

        throw new IllegalArgumentException ("Entity type not supported " + entityType);
    }

}