package de.hdm_stuttgart.battlearena.Model.Map;

import javafx.scene.image.Image;

import org.apache.logging.log4j.Logger;
import org.apache.logging.log4j.LogManager;

class BackgroundTile implements ITile{

    private static final Logger log = LogManager.getLogger(BackgroundTile.class);

    private final Image tileSprite;
    private final boolean isWalkable, isDestructible;

    public BackgroundTile(Image tileSprite, boolean isWalkable, boolean isDestructible) {
        this.tileSprite = tileSprite;
        this.isWalkable = isWalkable;
        this.isDestructible = isDestructible;
    }

    @Override
    public boolean getCollision() {
        log.debug("Collision type: " + isWalkable + " returned.");
        return isWalkable;
    }
    @Override
    public boolean getDestruction() {
        log.debug("Collision type: " + isDestructible + " returned.");
        return isWalkable;
    }

    @Override
    public Image getTileSprite() {
        log.debug("Image returned");
        return tileSprite;
    }
}