package de.hdm_stuttgart.battlearena.Model.Multiplayer;

import javafx.application.Application;
import javafx.scene.Scene;
import javafx.scene.input.KeyCode;
import javafx.scene.layout.Pane;
import javafx.scene.paint.Color;
import javafx.scene.shape.Rectangle;
import javafx.stage.Stage;
import java.util.concurrent.TimeUnit;

import java.io.IOException;

public class TestMap extends Application {
    private static final int SQUARE_SIZE = 50;
    private static Rectangle square;
    private static Rectangle enemy;
    private Color color = Color.BLACK;

    @Override
    public void start(Stage primaryStage) throws IOException, InterruptedException {

        ConnectionHandler handler = new ConnectionHandler();
        handler.startHandler();

        TimeUnit.SECONDS.sleep(1);

        square = new Rectangle(SQUARE_SIZE, SQUARE_SIZE, color);
        enemy = new Rectangle(SQUARE_SIZE, SQUARE_SIZE, color);

        Pane root = new Pane();
        root.getChildren().add(square);
        root.getChildren().add(enemy);

        Scene scene = new Scene(root, 400, 400);

        scene.setOnKeyPressed(event -> handleKeyPress(event.getCode(), handler));

        primaryStage.setTitle("Player #" + handler.getPlayerID());
        primaryStage.setScene(scene);
        primaryStage.show();

        if(handler.getPlayerID() == 1){
            square.setX(50);
            square.setY(50);
            enemy.setX(200);
            enemy.setY(50);
        } else if(handler.getPlayerID() == 2){
            square.setX(200);
            square.setY(50);
            enemy.setX(50);
            enemy.setY(50);
        }

        UpdateThread update = new UpdateThread(handler);
        update.start();

    }

    private void handleKeyPress(KeyCode code, ConnectionHandler handler) {
        switch (code) {
            case UP:
                square.setY(square.getY() - 20);
                handler.setpY(handler.getpY() - 20);
                break;
            case DOWN:
                square.setY(square.getY() + 20);
                handler.setpY(handler.getpY() + 20);
                break;
            case LEFT:
                square.setX(square.getX() - 20);
                handler.setpX(handler.getpX() - 20);
                break;
            case RIGHT:
                square.setX(square.getX() + 20);
                handler.setpX(handler.getpX() + 20);
                break;
        }
    }

    private static class UpdateThread extends Thread {
        private final ConnectionHandler handler;

        private UpdateThread(ConnectionHandler handler) {
            this.handler = handler;
        }

        public void run() {
            while (true){

                handler.setpX((int) square.getX());
                handler.setpY((int) square.getY());

                //receive cords
                enemy.setX(handler.getEnemyX());
                enemy.setY(handler.getEnemyY());


                try {
                    Thread.sleep(16);
                } catch (InterruptedException e) {
                    throw new RuntimeException(e);
                }
            }


        }
    }

    public static void main(String[] args) throws IOException {
            launch(args);
    }
}